## bumptech-stud-0.3-51-g0b88039.tar.gz

=== Makefile ===
# [g]make USE_xxxx=1
#
# USE_SHARED_CACHE   :   enable/disable a shared session cache (disabled by default)

DESTDIR =
PREFIX  = /usr/local
BINDIR  = $(PREFIX)/bin
MANDIR  = $(PREFIX)/share/man

CFLAGS  = -O2 -g -std=c99 -fno-strict-aliasing -Wall -W -D_GNU_SOURCE -I/usr/local/include
LDFLAGS = -lssl -lcrypto -lev -L/usr/local/lib
OBJS    = stud.o ringbuffer.o configuration.o

all: realall

# Shared cache feature
ifneq ($(USE_SHARED_CACHE),)
CFLAGS += -DUSE_SHARED_CACHE -DUSE_SYSCALL_FUTEX
OBJS   += shctx.o ebtree/libebtree.a
ALL    += ebtree

ebtree/libebtree.a: $(wildcard ebtree/*.c)
	make -C ebtree
ebtree:
	@[ -d ebtree ] || ( \
		echo "*** Download libebtree at http://1wt.eu/tools/ebtree/" ; \
		echo "*** Untar it and make a link named 'ebtree' to point on it"; \
		exit 1 )
endif

# No config file support?
ifneq ($(NO_CONFIG_FILE),)
CFLAGS += -DNO_CONFIG_FILE
endif

ALL += stud
realall: $(ALL)

stud: $(OBJS)
	$(CC) -o $@ $^ $(LDFLAGS)

install: $(ALL)
	install -d $(DESTDIR)$(BINDIR)
	install stud $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(MANDIR)/man8
	install -m 644 stud.8 $(DESTDIR)$(MANDIR)/man8

clean:
	rm -f stud $(OBJS)


.PHONY: all realall

=== debian/changelog ===
stud (0.3~0.20111212) unstable; urgency=low

  * Initial release.

 -- Charlie Root <root@interseek.com>  Mon, 12 Dec 2011 13:24:18 +0100

=== debian/control ===
Source: stud
Section: universe/net
Priority: optional
Maintainer: Charlie Root <root@example.com>
Build-Depends: debhelper (>= 7.0.50~)
Standards-Version: 3.9.2
Homepage: https://github.com/bumptech/stud

Package: stud
Section: universe/net
Priority: optional
Architecture: any
Depends: libc6 (>= 2.4), libev4 (>= 1:4.04), libssl0.9.8 (>= 0.9.8k-1) | libssl1.0.0 (>= 1.0.0e-1)
# Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Scalable TLS Unwrapping Daemon
 stud is a network proxy that terminates TLS/SSL connections and forwards
 the unencrypted traffic to some backend. It's designed to handle 10s of
 thousands of connections efficiently on multicore machines.
 .
 It follows a process-per-core model; a parent process spawns N children who
 each accept() on a common socket to distribute connected clients among them.
 Within each child, asynchronous socket I/O is conducted across the local
 connections using libev and OpenSSL's nonblocking API. By default, stud
 has an overhead of ~200KB per connection--it preallocates some buffer space
 for data in flight between frontend and backend.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

override_dh_auto_clean:
	rm -rf ebtree
	make clean

override_dh_auto_configure:
	if [ ! -f ebtree-6.0.6.tar.gz ]; then wget http://1wt.eu/tools/ebtree/ebtree-6.0.6.tar.gz; fi
	if [ ! -d ebtree ]; then tar zxpf ebtree-6.0.6.tar.gz; mv ebtree-6.0.6 ebtree; fi

override_dh_auto_build:
	make USE_SHARED_CACHE=1 PREFIX=/usr

override_dh_auto_install:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	make install DESTDIR=$(CURDIR)/debian/stud PREFIX=/usr

	# create stud instance configuration directory
	mkdir -p $(CURDIR)/debian/stud/etc/stud
	chown -R root:root $(CURDIR)/debian/stud/etc/stud
	chmod 700 $(CURDIR)/debian/stud/etc/stud
	echo "Run /etc/init.d/stud --sample-config > /etc/stud/something.conf for default instance configuration" >> "$(CURDIR)/debian/stud/etc/stud/README.TXT"

%:
	dh $@

# EOF
